<template>
  <div class="text-center">
    <v-btn
      :disabled="isDownloading"
      @click="downloadReportExcel()"
      color="primary"
      >Descargar Excel de la información</v-btn
    >
  </div>
</template>
<script>
import FileSaver from "file-saver";
import axios from "axios";
const now = new Date();
const quarter = Math.floor(now.getMonth() / 3);
export default {
  name: "Component-Excel",
  props: ["filters"],
  data() {
    return {
      isDownloading: false,
      globalFilters: {
        final_filters: {
          anio: null,
          descripcion_ceco: "",
          fecha_inicio: null,
          fecha_fin: null,
          id_ceco: null,
          id_disciplina: null,
          id_negocio: null,
          nivel_geografico: 4,
          numero_periodo: quarter + 1,
        },
      },
    };
  },
  methods: {
    downloadReportExcel() {
      console.log(this.filters);
      this.isDownloading = true;
      this.globalFilters.final_filters.id_disciplina = this.filters.path.idDisciplina;
      this.globalFilters.final_filters.id_ceco = this.filters.request.nivelCentroCostos;
      this.globalFilters.final_filters.fecha_fin = this.filters.request.fechaFin;
      this.globalFilters.final_filters.fecha_inicio = this.filters.request.fechaInicio;
      let url = "/reporte/medicion/intermedia/secure/get";
      if (
        this.globalFilters.final_filters.id_disciplina == 5 ||
        this.globalFilters.final_filters.id_disciplina == 24
      ) {
        url = "/reporte/medicion/7s/secure/get";
      }
      axios({
        method: "post",
        url: url,
        responseType: "blob",
        data: this.globalFilters.final_filters,
      })
        .then((response) => {
          if (response.headers["content-type"] !== "application/json") {
            FileSaver.saveAs(response.data, response.headers["file-name"]);
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(() => {
          this.isDownloading = false;
        });
    },
  },
};
</script>
